-- thanks to moebius92 for quest parsing idea/method

import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "RambleOnion.ChallengeTracker2.Utils";
import "RambleOnion.ChallengeTracker2.TrackerWindow";
import "RambleOnion.ChallengeTracker2.Settings";

function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end
function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

ChallengeTrackerMain = class();

function ChallengeTrackerMain:Constructor()
	self.settings = RambleOnion.ChallengeTracker2.Settings();
	self.TrackerWindow = RambleOnion.ChallengeTracker2.TrackerWindow(self.settings);
end


CTM = ChallengeTrackerMain();
chatHandler = function(f,args)
	if(args.ChatType == Turbine.ChatType.Quest) then
		local message = args.Message;
		if(string.sub(message,1,10) == "Completed:") then
			if(CTM.settings:Update(message)) then
				CTM.TrackerWindow:refreshCurrentTab();
			end
		end
	end
end
AddCallback(Turbine.Chat, "Received", chatHandler);

ChallengeTrackerCommand = class(Turbine.ShellCommand);

function ChallengeTrackerCommand:Execute(command,arguments)
	if(string.find(arguments,"show") ~= nil) then
		CTM.TrackerWindow:SetVisible(true);
	elseif(string.find(arguments,"hide") ~= nil) then
		CTM.TrackerWindow:SetVisible(false);
	else
		CTM.TrackerWindow:SetVisible(not CTM.TrackerWindow:IsVisible());
	end
end

function ChallengeTrackerCommand:GetHelp()
	return "Arguments: \nshow - Display the tracker window\nhide - Hide the tracker window\n[none] - Flip the state of the tracker window"; 
end

function ChallengeTrackerCommand:GetShortHelp()
	return "Hide/show the tracker window"; 
end

Turbine.Shell.WriteLine("Challenge Tracker by Quinby modifyed by Haphollas. Patched by Essimorko.");
challengeTrackerCommand = ChallengeTrackerCommand();
Turbine.Shell.AddCommand('ct',challengeTrackerCommand);

Plugins["Challenge Tracker"].Unload = function( sender, args )
        RemoveCallback(Turbine.Chat, "Received", chatHandler);
end